#include <fcntl.h>//
#include <io.h> //

/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher by Tomas Peceny, April 2002.

  Revision: 1990-09-30
  Modified by Daryl Baker for use in MS WINDOWS environment

  Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
  Copyright (c) 1988, 1989, 1990  John Stanback

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/

// #define NOATOM 
// #define NOCLIPBOARD
// #define NOCREATESTRUCT
// #define NOFONT
// #define NOREGION
// #define NOSOUND
// #define NOWH
// #define NOCOMM
// #define NOKANJI
 
#include <windows.h>
#include <TCHAR.H>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>

#include "resource.h"
#include "gnuchess.h"
#include "defs.h"
#include "chess.h"

#define MAX_BOOK_SIZE (32*10240)
extern int Krok;
extern TCHAR lpBtp[5];// ".btp"
char hBook[MAX_BOOK_SIZE];//
TCHAR JmenoOtevreni[MAX_PocetOtevreni][MAX_DELKAJmenaOtevreni+2];//
TCHAR *JmenoTohotoOtevreni;
unsigned char chOtevreni[MAX_DELKASouboruOtevreni+3];//+1// length: see also wOtevreni
//wchar_t *wOtevreni=(LPWSTR)chOtevreni;// for SaveBook() only, one game cannot be longer than MAX_DELKASouboruOtevreni/2 
extern HWND hWndTP;
extern int HvezdickaBTP;
extern short GameCntBezHvezdicky;
int vOtevreni; // position in chOtevreni
int NahodneOtevreni=TRUE; // 
struct BookEntry *pMinule=NULL;
//char CurrentDirectoryTP[MAX_PATH];// for debugging
TCHAR AdresaKnihovny[MAX_PATH];//  ends with '\' 
static unsigned int book_used = 0;
static char far * xBook;
//GLOBALHANDLE hBook = 0;

wchar_t getcTP(int Krok);

int JeOtevrenBTP(void)// adds or removes asterisk " *" to the window title
{TCHAR lTitulSHvezdickou[81+7+2];
 GetWindowText(hWndTP,lTitulSHvezdickou,81+7);//
 if(_tcsstr(_tcslwr(lTitulSHvezdickou),lpBtp))
	return TRUE;
 else
	return FALSE;
}

/* int GetCurrentDirectoryTP(void)// for debugging
{int DelkaCteneho=GetCurrentDirectory(MAX_PATH,CurrentDirectoryTP);
 return DelkaCteneho;
}*/

void FreeBook (void)
{
//   GlobalUnlock ( hBook );
//   GlobalFree ( hBook);
//   hBook = 0;
   book_used = 0;
}

static void far *Book_alloc ( unsigned int size )
{
    char far * temp;
    if ( book_used+size >= MAX_BOOK_SIZE ) return (void far *)0;
    temp = xBook+book_used;
    book_used += size;
    return temp;
}


int // void
GetOpenings (HWND hWnd, TCHAR *AdresaSouboru)// AdresaSouboru=="" ... original GetOpenings()
     
/*
   Read in the Opening Book file and parse the algebraic notation for a move
   into an unsigned integer format indicating the from and to square. Create
   a linked list of opening lines of play, with entry->next pointing to the
   next line and entry->move pointing to a chunk of memory containing the
   moves. More Opening lines of up to 256 half moves may be added to
   gnuchess.book.
*/
//#ifndef BOOK
//#define BOOK "/usr/games/lib/gnuchess.book"
//#endif /* BOOK */     
{
  //FILE *fd;
  int c, i, j, side;
  int Nahravany,Delka,jOtevreni,jJmeno; //
  /* char buffr[2048]; */
  struct BookEntry far  *entry;
  unsigned short mv, far  *mp, tmp[100];
  TCHAR RetezTP[30];//
/*  char lpFile[_MAX_FNAME+_MAX_EXT+_MAX_DRIVE+_MAX_DIR+1];
 // char sFname[_MAX_FNAME], sExt[_MAX_EXT], sDrive[_MAX_DRIVE], sDir[_MAX_DIR];
  //GetModuleFileName ( GetWindowWord(hWnd, GWW_HINSTANCE),
  //                    lpFile, sizeof(lpFile) ); //  now,gnuchess.boo must be in the current directory

 // _splitpath ( lpFile, sDrive, sDir, sFname, sExt);
 // _makepath  ( lpFile, sDrive, sDir, "gnuchess", "bTP");// "boo"

 // _fmode = _O_BINARY; did not repair reading file
 // fd = fopen (lpFile, "r");

  if ((fd = fopen (BOOK, "r")) == NULL)
    fd = fopen ("gnuchess.book", "r"); */
 if(AdresaSouboru[0]==0)
  {//strcpy(AdresaKnihovny,VychoziAdresar);
   TCHAR AdresaTady[MAX_PATH];
	_tcscpy(AdresaTady,AdresaKnihovny);
   LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                            GNUCHESS_BTP, RetezTP, 30);
   Nahravany=_topen(_tcscat(AdresaTady,RetezTP),_O_BINARY|_O_RDONLY);//
  }
 else
  Nahravany=_topen(AdresaSouboru,_O_BINARY|_O_RDONLY);//
 if(Nahravany!=-1)//(fd != NULL)
    {if(_filelength(Nahravany)>MAX_DELKASouboruOtevreni-3)
	    {_close(Nahravany);
        SMessageBox (hWnd, TOO_LONG_BTP, TITUL_CHESS);
		  return -1;
		 } 
	  Delka=_read(Nahravany,chOtevreni,MAX_DELKASouboruOtevreni);
     if(Delka!=_filelength(Nahravany))
	    {_close(Nahravany);
        SMessageBox (hWnd, BAD_READING_BTP, TITUL_CHESS);
		  return -2;
		 } 
	  _close(Nahravany);
	  chOtevreni[Delka]=0;
	  chOtevreni[Delka+1]=0;
	  chOtevreni[Delka+2]=0;

//      hBook = GlobalAlloc ( GMEM_MOVEABLE | GMEM_ZEROINIT,
//                            (long) (MAX_BOOK_SIZE * sizeof (char)) );

      if( hBook == NULL )
        {
           Book = NULL;
           SMessageBox (hWnd, IDS_OBAE, TITUL_CHESS);
           return -3;
        }
      xBook = hBook;//(unsigned char far *) GlobalLock (hBook);

      Book = NULL;
      i = 0;
      side = white;
		jOtevreni=0;
		vOtevreni=0;
		Krok=1;// Krok==1 ...non UNICODE *.bTP, Krok==2 ... UNICODE 
		if((c = chOtevreni[0]) != 0xFF)
		  {vOtevreni=0;
			goto ZaFFFE;
		  }
		if((c = chOtevreni[1]) != 0xFE)
		  {SMessageBox (hWndTP, BTP_STARTS_WITH_ONLY_PART, TITUL_CHESS);
		   vOtevreni=1;
			goto ZaFFFE;
		  }
		vOtevreni=2;
		Krok=2;
ZaFFFE:
      while ((c = parse (/* fd,*/Delka, &mv, side,&JmenoOtevreni[jOtevreni][0])) >= 0)
       {if (c == 2) // the opening name
			  {if(jOtevreni>MAX_PocetOtevreni-2)   
				  { SMessageBox (hWnd, TOO_MANY_OPENING_NAMES, TITUL_CHESS);
                //Book = NULL;
                //SMessageBox (hWnd, IDS_OBAE, IDS_CHESS);
                //GlobalUnlock ( hBook );
                //GlobalFree ( hBook);
                return -4;
				  }
				if(i>0)
				  {jJmeno=jOtevreni-1;
					jOtevreni++;
					goto PoJmenu;
				  }
				jOtevreni++;
				continue;
			  }
		  if (c == 1)
          {
            tmp[++i] = mv;
            side = otherside[side];
          }
        else if (c == 0 && i > 0)
          { jJmeno=jOtevreni-1;
PoJmenu:
            entry = (struct BookEntry far *) Book_alloc ( sizeof (struct BookEntry));
            mp = (unsigned short far *) Book_alloc ( (i + 1) * sizeof (unsigned short));
            if ( (entry == 0 ) || (mp == 0) )
              {
                Book = NULL;
                SMessageBox (hWnd, IDS_OBAE, TITUL_CHESS);
                //GlobalUnlock ( hBook );
                //GlobalFree ( hBook);
                return -5;
              }
            entry->mv = mp;
            entry->next = Book;
				entry->pJmeno=&JmenoOtevreni[jJmeno][0];//  ==JmenoOtevreni[jJmeno]
            Book = entry;
            for (j = 1; j <= i; j++)
              *(mp++) = tmp[j];
            *mp = 0;
            i = 0;
            side = white;
          }
		 }
  //    fclose (fd);
//		 MessageBox ( NULL, JmenoOtevreni[jOtevreni-1], "Chess", MB_OK );
	  return 0;
    }
  else
    {SMessageBox (hWnd, IDS_OBNF, TITUL_CHESS);
	  return -6;
	 }
}

void
OpeningBook (unsigned short *hint)

/*
  Go thru each of the opening lines of play and check for a match with the
  current game listing. If a match occurs, generate a random number. If this
  number is the largest generated so far then the next move in this line
  becomes the current "candidate". After all lines are checked, the
  candidate move is put at the top of the Tree[] array and will be played by
  the program. Note that the program does not handle book transpositions.
*/

{
  short j, pnt;
  unsigned short m, far *mp;
  unsigned r, r0;
  struct BookEntry far *p;
  srand ((unsigned int) time (NULL));
  r0 = m = 0;
  if(!NahodneOtevreni)//
		goto MimoCyklus;// 
  p = Book;
  while (p != NULL)
    {mp = p->mv;
      for (j = 1; j <= GameCnt; j++)
        if (GameList[j].gmove != *(mp++))
           break;
      if (j > GameCnt)
		 {if ((r = urand ()) > r0)
          {
            r0 = r;
            m = *mp;
            *hint = *(++mp);
				JmenoTohotoOtevreni=p->pJmeno;
				pMinule=p;
          }
		 }
      p = p->next;
    }
  goto ZaMimo;
MimoCyklus:
		mp = pMinule->mv;
      for (j = 1; j <= GameCnt; j++)
        if (GameList[j].gmove != *(mp++))
          goto ZaMimo; // break;
      if (j > GameCnt)
		   {
            m = *mp;
            *hint = *(++mp);
				JmenoTohotoOtevreni=pMinule->pJmeno;
          }
ZaMimo:
  for (pnt = TrPnt[1]; pnt < TrPnt[2]; pnt++)
    if (((Tree[pnt].f << 8) | Tree[pnt].t) == m)
      Tree[pnt].score = 0;
  pick (TrPnt[1], TrPnt[2] - 1);
  if (Tree[TrPnt[1]].score < 0) {
   FreeBook ();
   Book = NULL;
	if(JeOtevrenBTP())
	  {HvezdickaBTP=FALSE;
		GameCntBezHvezdicky=GameCnt;//
	  }
  }
}
