/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher by Tomas Peceny, April 2002.

  Revision: 1990-09-30
  Modified by Daryl Baker for use in MS WINDOWS environment

  Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
  Copyright (c) 1988, 1989, 1990  John Stanback

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/

#include <windows.h>
#include <TCHAR.H >
#include <string.h>
#include <stdio.h>

#include "resource.h"
#include "gnuchess.h"
#include "chess.h"
#include "defs.h"
#include "stats.h"

#define DELKA_ZREDENEHO 100
char Otaznik='?';
extern int WhiteTimeExhausted,BlackTimeExhausted; //
extern int TCminutesWhite,TCminutesBlack;//
extern int Zavorky,MakeMessageTime; //
extern HWND hWndTP;
int PrvniNaTahu;//
int ComputerMates,FlagDraw,//
	 BylSwitch;// 
short computerSta,playerSta;//
extern TCHAR lpBtp[5];// ".btp"
extern TCHAR lpAsterisk[5];// " *"
TCHAR lpProcento_d_c[5];// "%d%c"
extern TCHAR lpProcento_D[30];


extern short boarddraw[64];
extern short colordraw[64];

extern TCHAR TITUL_Chess[30];
extern char mvstr[4][6];
extern long evrate;
TCHAR Zredene[DELKA_ZREDENEHO];
wchar_t wZredene[DELKA_ZREDENEHO];
char Zhustene[DELKA_ZREDENEHO];
TCHAR  ColorStr[2][15];// == {"White", "Black"};
extern TCHAR *JmenoTohotoOtevreni;//
extern HANDLE hInstTP;
extern HWND hWndTP;
extern int HvezdickaBTP,KrizekCasu;
extern int HvezdickaStale;//
extern short GameCntBezHvezdicky;
void NapisHvezdicku(HWND hWnd,int MaBytHvezdicka);//
LPTSTR Zred(LPSTR Src);

void ProhodStrany()//
{struct TimeControlRec tStara=TimeControl;
 int iStara=TCminutesWhite;
 TCminutesWhite=TCminutesBlack;
 TCminutesBlack=iStara;
 TimeControl.clock[computer]=tStara.clock[opponent];
 TimeControl.clock[opponent]=tStara.clock[computer];
 computer = otherside[computer];
 opponent = otherside[opponent];
 if(!TCflag)
	{if(computer==white)
			Level = 60 * (long) TCminutesWhite;
	 else
			Level = 60 * (long) TCminutesBlack;
	}
}

void
ShowPlayers (void)
  /* display in the status line what color the computer is playing */
{TCHAR RetezTP[30];
 if(flag.bothsides) //
  {LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 COMPUTER_BOTH, RetezTP, 30);
	SetWindowText ( hComputerColor, RetezTP);
	return;
  }
 if(flag.force)//
  SetWindowText ( hComputerColor, lpEmpty);
 else
  {LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
			(computer == black) ? COMPUTER_IS_BLACK :COMPUTER_IS_WHITE, RetezTP, 25);
   SetWindowText ( hComputerColor,RetezTP);
  }
}

void
ShowJmenoOtevreni (void)//
{
  /* in the status line, display the name of present opening */
 if(Book == NULL)
  SetWindowText ( hJmenoOtevreni, lpEmpty);
 else
  SetWindowText ( hJmenoOtevreni, JmenoTohotoOtevreni);
}
void ShowNapis (int CisloStr)//
  /* in the status line, display a message instead of the SMessageBox() */
{ TCHAR Retez[80];
  LoadString(hInstTP,  // handle of module containing string resource 
				CisloStr,  // resource identifier
				Retez, // address of buffer for resource 
				80); // size of buffer 
  SetWindowText ( hJmenoOtevreni,Retez);
}

void
ShowDepth (char ch)
{  TCHAR Tch=ch;
   TCHAR tmp[30];
   if ( hStats ) {
      wsprintf ( tmp, lpProcento_d_c, Sdepth, Tch);
      SetDlgItemText ( hStats, DEPTHTEXT, tmp);
   }
}

void
ShowScore (short score)
{
   TCHAR tmp[30];
   if ( hStats) {
      wsprintf ( tmp, lpProcento_D,score);
      SetDlgItemText ( hStats, SCORETEXT, tmp);
   }
}

void SMessageBox ( HWND hWnd, int str_num, int str1_num )
{
   TCHAR str[400], str1[20];
   LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
					 str_num, str, 400);
   LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE), 
	             str1_num, str1, 20);
   MessageBox ( hWnd, str, str1, MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL );
}

void
ClearMessage (void)
{
}

void
ShowCurrentMove (short int pnt, short int f, short int t)
{
   char tmp[30];

   if ( hStats) {
      algbr (f, t, false);
      sprintf ( tmp, "(%2d) %4s",pnt, (char far *)mvstr[0]);
      SetDlgItemText ( hStats, POSITIONTEXT, Zred(tmp));
   }
}

void
ShowSidetoMove (void)
{
   TCHAR tmp[35];
   TCHAR RetezTahu[20],RetezFormat[25];//
	LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 IT_IS_S_TURN, RetezFormat, 25);
   wsprintf ( tmp, RetezFormat,ColorStr[player]);
   SetWindowText ( hWhosTurn, tmp);
	if(flag.easy)
   {if(PrvniNaTahu==white)//
	 {/*if ( player == black )  //
	  {wsprintf (RetezTahu,"White %3d.",(GameCnt+1)/2);
      SetWindowText (hMsgWhite,RetezTahu);
		wsprintf (RetezTahu,"Black %3d.",(GameCnt-1)/2);
      SetWindowText (hMsgBlack,RetezTahu);
     } 
	  else */
	  {_tcscpy(RetezFormat,ColorStr[white]);
		LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 PROCENTO_3D_, RetezFormat+_tcsclen(RetezFormat), 6);// "White %3d."
	   wsprintf (RetezTahu,RetezFormat,(GameCnt+1)/2);
      SetWindowText (hMsgWhite,RetezTahu);
		_tcscpy(RetezFormat,ColorStr[black]);
		LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 PROCENTO_3D_, RetezFormat+_tcsclen(RetezFormat), 6);// "Black %3d."
		wsprintf (RetezTahu,RetezFormat,(GameCnt)/2);
      SetWindowText (hMsgBlack,RetezTahu);
     }
	 }
	 else //PrvniNaTahu==black
	 {{_tcscpy(RetezFormat,ColorStr[white]);
		LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 PROCENTO_3D_, RetezFormat+_tcsclen(RetezFormat), 6);// "White %3d."
		wsprintf (RetezTahu,RetezFormat,(GameCnt+2)/2);
      SetWindowText (hMsgWhite,RetezTahu);
		_tcscpy(RetezFormat,ColorStr[black]);
		LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 PROCENTO_3D_, RetezFormat+_tcsclen(RetezFormat), 6);// "Black %3d."
		wsprintf (RetezTahu,RetezFormat,(GameCnt+1)/2);
      SetWindowText (hMsgBlack,RetezTahu);
     } 
	 }
	}
	else // !flag.easy
	  {SetWindowText (hMsgWhite,ColorStr[white]);
      SetWindowText (hMsgBlack,ColorStr[black]);
     }
}

void
ShowPrompt (void)
{
}

void
ShowNodeCnt (long int NodeCnt, long int evrate)
{
   char tmp[40];

   if ( hStats ) {
      sprintf ( tmp,"%-8ld", NodeCnt);
      SetDlgItemText ( hStats, NODETEXT, Zred(tmp));
      sprintf ( tmp,"%-5ld", evrate);
      SetDlgItemText ( hStats, NODESECTEXT, Zred(tmp));
   }
}  

void
ShowResults (short int score, short unsigned int *bstline, char ch)
{
  unsigned char d, ply;
  char str[300];
  int s;

  if (flag.post)
    {
      ShowDepth (ch);
      ShowScore (score);
      d = 7; s = 0;
      for (ply = 1; bstline[ply] > 0; ply++)
        {
         algbr ((short) bstline[ply] >> 8, (short) bstline[ply] & 0xFF, false);
         if ( ply==5 || ply==9 || ply==13 || ply==17)
            s += sprintf ( str+s,"\n");
         s += sprintf ( str+s,"%-5s ", (char far *) mvstr[0]);
        }
      SetDlgItemText ( hStats, BSTLINETEXT, Zred(str));
    }
}

void
SearchStartStuff (short int side)
{
}

LPTSTR Zred(LPSTR SrcTP)// transforms strings char[] to TCHAR[]
{
#ifdef UNICODE
	int LPocet=MultiByteToWideChar(
	  CP_ACP,//UINT CodePage,         // code page
	  MB_PRECOMPOSED,//DWORD dwFlags, // character-type options
	  SrcTP,//LPCSTR lpMultiByteStr, // address of string to map
	  -1,//int cchMultiByte,      // number of bytes in string
	  Zredene,//LPWSTR lpWideCharStr,  // address of wide-character buffer
	  DELKA_ZREDENEHO);//int cchWideChar        // size of buffer
   return Zredene;
#else
   return (LPTSTR)SrcTP;
#endif
}

LPWSTR wZred(LPSTR SrcTP)// transforms strings char[] to wchar_t[]
{
	int LPocet=MultiByteToWideChar(
	  CP_ACP,//UINT CodePage,         // code page
	  MB_PRECOMPOSED,//DWORD dwFlags, // character-type options
	  SrcTP,//LPCSTR lpMultiByteStr, // address of string to map
	  -1,//int cchMultiByte,      // number of bytes in string
	  wZredene,//LPWSTR lpWideCharStr,  // address of wide-character buffer
	  DELKA_ZREDENEHO);//int cchWideChar        // size of buffer
   return wZredene;
}

// Due to MesageBox text usable only in SaveBook(). It returns NULL if not success.
LPSTR Zhusti(LPTSTR SrcTP)// transforms short strings TCHAR[] to char[]  
{
#ifdef UNICODE
	int BylDefaultZhusteni;
	TCHAR RetezTP[500];
	int Pocet=WideCharToMultiByte(
	  CP_ACP,//UINT CodePage,         // code page
	  WC_COMPOSITECHECK,//WC_DEFAULTCHAR does not work,//WC_NO_BEST_FIT_CHARS only from NT 5.0,//DWORD dwFlags, // performance and mapping flags
	  SrcTP,//LPCWSTR lpWideCharStr, // address of wide-character string
	  -1,//LDelka+1,//int cchWideChar,       // number of characters in string
	  Zhustene,//LPSTR lpMultiByteStr,// address of buffer for new string
	  DELKA_ZREDENEHO,//int cchMultiByte,      // size of buffer
	  &Otaznik,//LPCSTR lpDefaultChar,  // address of default for unmappable characters
	  &BylDefaultZhusteni);//LPBOOL lpUsedDefaultChar   // address of flag set when default 
                             // char. used
	if(BylDefaultZhusteni)
	  {LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                          OPENING_NAME_CONTAIN, RetezTP, 500);
		if ( MessageBox ( hWndTP,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
         return NULL;
	  }
   return Zhustene;
#else
   return (LPSTR)SrcTP;
#endif
}

void
OutputMove (HWND hWnd)
{
  TCHAR tmp[30],FormatTP[25];
  NapisHvezdicku(hWndTP,HvezdickaStale || GameCnt!=GameCntBezHvezdicky);//
  UpdateDisplay (hWnd, root->f, root->t, 0, (short) root->flags);
  LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 MY_MOVE_IS_S, FormatTP, 25);
  wsprintf ( tmp, FormatTP,Zred(mvstr[0]));
  if(flag.force)//
		SetWindowText ( hComputerMove, lpEmpty);
  else
		SetWindowText ( hComputerMove, tmp);
  ShowJmenoOtevreni();

  if (root->flags & draw)
    {SMessageBox ( hWnd, IDS_DRAWGAME, TITUL_CHESS);
	  if(flag.bothsides)// experimentally, it enables correct Undo and Redo
	    {flag.bothsides=FALSE;
		 }
	  FlagDraw=TRUE;
	  GameCountNejv=GameCnt;//
	 }
  else if (root->score == -9999)
    {ShowSidetoMove();//
	  SMessageBox ( hWnd, IDS_YOUWIN, TITUL_CHESS);
	  if(flag.bothsides)//
	    {flag.bothsides=FALSE;
		 }
	  ComputerMates=FALSE;// not necessary here
	  GameCountNejv=GameCnt;//
	 }
  else if (root->score == 9998)
    {ShowSidetoMove();//
	  SMessageBox ( hWnd, IDS_COMPUTERWIN, TITUL_CHESS);
	  flag.bothsides=FALSE;
	  ComputerMates=TRUE;//
	  GameCountNejv=GameCnt;//
	 }
  else if (root->score < -9000)
    ShowNapis (IDS_MATESOON);// SMessageBox ( hWnd, IDS_MATESOON,IDS_CHESS);
  else if (root->score > 9000)
    ShowNapis (IDS_COMPMATE);// SMessageBox ( hWnd, IDS_COMPMATE,IDS_CHESS);
  if (flag.post)
    {
      ShowNodeCnt (NodeCnt, evrate);
/*
      for (i = 1999; i >= 0 && Tree[i].f == 0 && Tree[i].t == 0; i--);
      printz ("Max Tree= %5d", i);
*/
    }
}

void
UpdateClocks (void)
{
  short m, s,
		mO,sO;//
  TCHAR tmp[20],
	   tmpO[20],FormatTP[25];//

  m = (short) (et / 60);
  s = (short) (et - 60 * (long) m);
  if (TCflag)
    {m = (short) ((TimeControl.clock[player] - et) / 60);
     s = (short) (TimeControl.clock[player] - et - 60 * (long) m);
	 mO = (short) ((TimeControl.clock[otherside[player]]/* - et*/) / 60);//
     sO = (short) (TimeControl.clock[otherside[player]]/* - et*/ - 60 * (long) mO);//
	  if (m < 0) m = 0;
	  if (s < 0) s = 0;
	  if (mO < 0) mO = 0;//
	  if (sO < 0) sO = 0;//
	  if(m==0 && s==0 && !Zavorky) //
	    {if(player==white)
		    {if(!WhiteTimeExhausted)
			    {WhiteTimeExhausted=TRUE;
				  MessageBeep (MB_ICONEXCLAMATION);
				  if(MakeMessageTime)
						SMessageBox (hWndTP,WHITE_HAS_EXHAUSTED_HIS_TIME, TITUL_CHESS);
				 }
			 }
		  else //player==black
		    {if(!BlackTimeExhausted)
			    {BlackTimeExhausted=TRUE;
				  MessageBeep (MB_ICONEXCLAMATION);
				  if(MakeMessageTime)
						SMessageBox (hWndTP,BLACK_HAS_EXHAUSTED_HIS_TIME, TITUL_CHESS);
				 }
			 }
		 }
    }
  if(KrizekCasu)
	  {if(Zavorky)
			LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 CROSS_BRACK_0D_02D, FormatTP, 25);
		else
			LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 CROSS_0D_02D, FormatTP, 25);
	  }
  else
	  {if(Zavorky)
			LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 BRACK_0D_02D, FormatTP, 25);
		else
			LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
					 _0D_02D, FormatTP, 25);
	  }
  wsprintf (tmp,FormatTP,m,s);
  if (TCflag)
		wsprintf (tmpO,FormatTP,mO,sO);
  if ( player == white )
     {SetWindowText (hClockWhite, tmp);
	  if (TCflag)
		SetWindowText (hClockBlack, tmpO);//
     }
  else 
     {SetWindowText (hClockBlack, tmp);
	  if (TCflag)
		SetWindowText (hClockWhite, tmpO);//
     }

  if (flag.post)
    ShowNodeCnt (NodeCnt, evrate);
}

void 
ShowPostnValue (short int sq)
{
}

void
ShowPostnValues (void)
{
}

void DrawPiece ( HWND hWnd, short int f )
{
   POINT aptl[4];
   HRGN hRgn;
   int x,y;

   if ( flag.reverse ) {
     x = 7-(f%8);
     y = 7-(f/8);
   } else {
      x = f%8;
      y = f/8;
   }

   QuerySqCoords ( x,y, aptl+0);
   hRgn = CreatePolygonRgn( aptl, 4, WINDING);
   InvalidateRgn ( hWnd, hRgn, FALSE );
   DeleteObject ( hRgn);
}

void NapisHvezdicku(HWND hWnd,int MaBytHvezdicka)// adds or removes asterisk " *" to the window title
{TCHAR TitulSHvezdickou[81+7+2],lTitulSHvezdickou[81+7+2];
 int MaBytHvezdickaBTP=FALSE;
 GetWindowText(hWnd,TitulSHvezdickou,81+7);//
 _tcscpy(lTitulSHvezdickou,TitulSHvezdickou);
 if(_tcsstr(_tcslwr(lTitulSHvezdickou),lpBtp))
	if(HvezdickaBTP)
		MaBytHvezdickaBTP=TRUE;

 if(_tcsstr(TitulSHvezdickou,lpAsterisk))
   {
	 if(!(MaBytHvezdicka||MaBytHvezdickaBTP))
		TitulSHvezdickou[_tcsstr(TitulSHvezdickou,lpAsterisk)-TitulSHvezdickou]=0;  // remove
   }
 else
   {if(MaBytHvezdicka||MaBytHvezdickaBTP)
		_tcscat(TitulSHvezdickou,lpAsterisk);  // add
   }
 SetWindowText(hWnd,TitulSHvezdickou);//
}

void
UpdateDisplay (HWND hWnd, short int f, short int t, short int redraw, short int isspec)
{
  short sq;
  
  for (sq=0; sq<64; sq++) {
         boarddraw[sq] = board[sq];
         colordraw[sq] = color[sq];
  }

  if (redraw){
      InvalidateRect ( hWnd, NULL, TRUE);
      ShowPlayers ();
		ShowJmenoOtevreni();
      UpdateWindow ( hWnd );
  } else {
      DrawPiece (hWnd, f);
      DrawPiece (hWnd, t);
      if (isspec & cstlmask)
        if (t > f)
          {
            DrawPiece (hWnd, f + 3);
            DrawPiece (hWnd, t - 1);
          }
        else
          {
            DrawPiece (hWnd, f - 4);
            DrawPiece (hWnd, t + 1);
          }
      else if (isspec & epmask)
        {
          DrawPiece (hWnd, t - 8);
          DrawPiece (hWnd, t + 8);
        }
      UpdateWindow (hWnd);
    }
}
