/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher by Tomas Peceny, April 2002.

  Revision: 1991-01-18
  Modified by Daryl Baker for use in MS WINDOWS environment

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/

#include <windows.h>
#include <TCHAR.H>
#include "chess.h"
#include "gnuchess.h"
#include "defs.h"
#include "resource.h"//

extern TCHAR lpEmpty[1];// ""
extern char mvstr[4][6];
extern unsigned short hint;
static TCHAR ManualDlgChar[8];

LPTSTR Zred(LPSTR SrcTP);
int FAR DoManualMoveDlg (HANDLE hInst, HWND hWnd, char * szPrompt);
int FAR DoHintDlg (HANDLE hInst, HWND hWnd);
BOOL CALLBACK ManualMoveDlgProc (HWND hDlg, UINT iMessage, // BOOL FAR PASCAL
                                  WPARAM wParam, LPARAM lParam)
{
   switch ( iMessage ){
      case WM_INITDIALOG:
         SendMessage ( GetDlgItem(hDlg, 100), EM_LIMITTEXT, 8-1,0);
         SetDlgItemText (hDlg, 100, ManualDlgChar);
         return TRUE;

      case WM_SYSCOMMAND:
         if ( (wParam&0xfff0) == SC_CLOSE ) {
   		      EndDialog(hDlg, FALSE);
	   	      return TRUE;
         }
         return FALSE;
         break;

      case WM_COMMAND:
         switch (wParam) {
            case IDOK:
               GetDlgItemText ( hDlg, 100, ManualDlgChar, 8-1); 
               EndDialog ( hDlg, TRUE);
               break;

            case IDCANCEL:
               EndDialog ( hDlg, FALSE);
               break;

            default: return FALSE;

         }

      default: return FALSE;
   }
   return TRUE;
}

BOOL CALLBACK HintDlgProc (HWND hDlg, UINT iMessage,
                                  WPARAM wParam, LPARAM lParam)//
{
   switch ( iMessage ){
      case WM_INITDIALOG:
      //   SendMessage ( GetDlgItem(hDlg, 100), EM_LIMITTEXT, sizeof(ManualDlgChar)-1,0);
         SetDlgItemText (hDlg, IDC_EDIT1, Zred(mvstr[0]));
         return TRUE;

      case WM_SYSCOMMAND:
         if ( (wParam&0xfff0) == SC_CLOSE ) {
   		      EndDialog(hDlg, FALSE);
	   	      return TRUE;
         }
         return FALSE;
         break;

      case WM_COMMAND:
         switch (wParam) {
            case IDOK:
               EndDialog ( hDlg, TRUE);
               break;

            case IDCANCEL:
               EndDialog ( hDlg, FALSE);
               break;

            default: return FALSE;

         }

      default: return FALSE;
   }
   return TRUE;
}

int FAR DoManualMoveDlg (HINSTANCE hInst, HWND hWnd, char * szPrompt)
{
   int stat;

   _tcscpy ( ManualDlgChar, lpEmpty);

   stat = DialogBox ( hInst, MAKEINTRESOURCE(MANUALDLG), hWnd, ManualMoveDlgProc);
#ifdef UNICODE
  {int k;
   for(k=0;k<8;k++)
		*(szPrompt+k)=(char)*(ManualDlgChar+k);
  }
#else
   lstrcpy ( szPrompt, ManualDlgChar);
#endif
   return stat;
}

int FAR DoHintDlg (HINSTANCE hInst, HWND hWnd)//
{
   int stat;
   algbr ((short) (hint >> 8), (short) (hint & 0xFF), false);// from GiveHint()
   stat = DialogBox ( hInst, MAKEINTRESOURCE(HINTDLGTP), hWnd, HintDlgProc);
   if(stat)
		PostMessage ( hWnd, MSG_MANUAL_ENTRY_POINT, 0, 0);
   return stat;
}

