/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher by Tomas Peceny, April 2002.

  Revision: 1990-09-30
  Modified by Daryl Baker for use in MS WINDOWS environment

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/

#include <windows.h>
#include "gnuchess.h"
#include "stats.h"

HWND hStats = NULL;
extern TCHAR lpEmpty[1];// ""
BOOL CALLBACK StatDlgProc ( HWND hDlg, UINT message,
                               WPARAM wParam, LPARAM lParam);


int StatDialog ( HWND hWnd, HINSTANCE hInst)
{	hStats = CreateDialog (hInst, MAKEINTRESOURCE(STATS), hWnd, StatDlgProc);// lpProcStat
   return (int)hStats;
}

BOOL CALLBACK StatDlgProc ( HWND hDlg, UINT message, // BOOL FAR PASCAL
                               WPARAM wParam, LPARAM lParam)
{   switch (message) {
	   case WM_INITDIALOG:		   /* message: initialize dialog box */

         SetDlgItemText (hDlg, DEPTHTEXT,    lpEmpty);
         SetDlgItemText (hDlg, POSITIONTEXT, lpEmpty);
         SetDlgItemText (hDlg, NODETEXT,     lpEmpty);
         SetDlgItemText (hDlg, BSTLINETEXT,  lpEmpty);
         SetDlgItemText (hDlg, SCORETEXT,    lpEmpty);
         SetDlgItemText (hDlg, NODESECTEXT,  lpEmpty);
         
         return (TRUE);

      case WM_SYSCOMMAND:
         if ( (wParam&0xfff0) == SC_CLOSE ) {
               DestroyWindow (hDlg);
	   	      return TRUE;
         }
         break;

      case WM_DESTROY:
         hStats = NULL;
         flag.post = false;
         break;
    }

    return (FALSE);			      /* Didn't process a message    */
}
